\documentclass[10pt]{report}
\usepackage{graphicx}
\usepackage[utf8]{inputenc}
\usepackage{xcolor}

\usepackage{hyperref} %Hyperlink


\title{\textbf{PiLUP board Low Level development handbook}}
\author{Gabriele D'Amen, Giuseppe Gebbia}
\date{12 February 2018}

\begin{document}
\maketitle
\tableofcontents

\chapter{Introduction}

\chapter{System Setup}
\section{Prerequisites}
The test setup runs Vivado 2017.4 under CentOS 7. 
The latest PetaLinux distribution can be found at \href{https://www.xilinx.com/support/download/index.html/content/xilinx/en/downloadNav/embedded-design-tools.html}{PetaLinux on Xilinx.com}. The PetaLinux version must match the Vivado/SDK distribution number.

\subsection{Install PetaLinux}
Create a new directory for Petalinux (in this case called PetaLinux).
Enter the directory in which you've downloaded the PetaLinux installer (in this case, Downloads). Run the PetaLinux installer using the install directory as an argument.
\begin{verbatim}
mkdir PetaLinux
cd [PATH/TO/INSTALLER/]Downloads
./petalinux-v[your_version]-final-installer-dec.run [PATH/TO/PETALINUX/]PetaLinux
\end{verbatim}
Download and install the following dependencies for PetaLinux\\\ \\
\begin{minipage}{.33333\textwidth}
\begin{verbatim}
tofrodos
iproute
gawk
gcc
git-core
make
net-tools
ncurses-devel
linbcurses5-dev
tftpd*
zlib1g-dev
flex
bison
\end{verbatim}
\end{minipage}
\begin{minipage}{.33333\textwidth}
\begin{verbatim}
lib32z1
lib32ncurses5
lib32bz2-1.0
ia32gcc1
lib32stdc++6
libselinux1
dos2unix
xorg-x11-server-Xvb
gcc-c++
git
openssl-devel
chrpath
diffstat
\end{verbatim}
\end{minipage}
\begin{minipage}{.33333\textwidth}
\begin{verbatim}
socat
xterm
autoconf
libtool
texinfo
SDL-devel
glibc-devel
glibc.i686
glib2-devel
screen
automake
pax
patch
\end{verbatim}
\end{minipage}


\subsection{Environmental variables}

Before starting PetaLinux, source (or add to your .bashrc file):
\begin{verbatim}
source [PATH/TO/PETALINUX/INSTALL]/settings.sh
source [PATH/TO/XILINX/INSTALL]/settings64.sh
\end{verbatim}

\subsection{Compile and Configure PetaLinux}
Generate the project workspace directory:
\begin{verbatim}
petalinux-create --type project --template zynq --name <name>
\end{verbatim}
where '-t' is equivalent to '--type'. A new directory will be created. \footnote{See ug1144-petalinux-tools-reference-guide.pdf} \footnote{flags --project can be omitted cd'ing into project dir}

Open the configuration menu (menuconfig) with default settings automatically configuring a FSBL (\textit{First Stage BootLoader}) and DTB (\textit{Device Tree Blob}) from the given .hdf (relevant menuconfig submenu: "AUTO hardware Settings"). It is not necessary to generate FSBL and DTB from SDK unless special configuration is required.
\begin{verbatim}
petalinux-config --get-hw-description <project_sdk_dir> --project <name>
\end{verbatim}

In order to configure the ethernet connectivity, navigate menuconfig:
\begin{verbatim}
Subsystem AUTO Hardware Settings
Ethernet Settings
Obtain IP address automatically
\end{verbatim}
check to have the board use a DHCP client to get its IP, uncheck for P2P connection.
In the latter case, set the following parameters as you prefer:
\begin{verbatim}
(192.168.0.11) Static IP address (NEW)
(255.255.255.255) Static IP Netmask (NEW)
(192.168.0.1) Static IP Gateway (NEW)
\end{verbatim}

\subsubsection{OPTIONAL: Enable Flash Boot:}
Go to: \\\texttt{Subsystem AUTO hardware settings $\rightarrow$\\
Advanced bootable images storage settings $\rightarrow$\\
boot image settings $\rightarrow$
\begin{center}Image storage media $\rightarrow$ Set as "primary flash"\\
kernel image settings $\rightarrow$ Set as "primary flash"\\
dtb image settings $\rightarrow$ Set as "from boot image"
\end{center}
}

\subsubsection{OPTIONAL: to set user-specified device tree entries/overrides:}
Edit "project-spec/meta-user/recipes-bsp/device-tree/files/system-user.dtsi"

\subsubsection{OPTIONAL: Manual KERNEL/ROOTFS-BUSYBOX configuration:}
from the kernel/rootfs menuconfig
\begin{verbatim}
(optional) petalinux-config -c <rootfs/kernel> --project <name>
\end{verbatim}

To build the project:
\begin{verbatim}
petalinux-build --project <name>
\end{verbatim}

\subsubsection{OPTIONAL: generate 'image' (ie BIN for SD or QSPI boot, if required)}
\begin{verbatim}
petalinux-package \
    --boot \
    --format <image> \
    --project <name> \
    --fsbl </PATH/TO/Zynq_FSBL.elf> \
    --fpga </PATH/TO/system_wrapper.bit> \
    --u-boot
\end{verbatim}

and populate "prebuilt" directory:
\begin{verbatim}
petalinux-package --prebuilt --fpga <FPGA bitstream>
\end{verbatim}
\section{JTAG Boot procedure}
\subsection{JTAG Boot with PetaLinux}
Boot via JTAG; the '--fpga' flag is used to load the bitstream (while not necessary). 
For some reason this refuse to load bitstream even with --bitstream option.
\begin{verbatim}
petalinux-boot --jtag --fpga --prebuilt 3
\end{verbatim}
The images are searched in the 'prebuilt' directory.


\subsection{JTAG Boot with VIVADO XSCT}

Load the script:
\begin{verbatim} 
BOOT_system.tcl
\end{verbatim}

\chapter{Logic structure}

\chapter{ZYNQ side}

\section{Connect to ZYNQ CPU via Ethernet direct link}
The PiLUP, at boot time, requests an IP(via DHCP requests); in order to perform direct link connections.
Once the system is set up, configure the net parameters.
The PiLUP is already configured with the IP address:\\
\begin{verbatim}
192.168.1.2/30
\end{verbatim}
Connect the ethernet cable and digit:
\begin{verbatim}
ip addr add <IP_ADDRESS> dev <NAME>
\end{verbatim}
where IP\_ADDRESS is the address you set previously and NAME is the name of the network interface of your system.\\
Now you can SSH/SFTP/whatever else directly to the board.\\

\section{Adding Custom Applications}\footnote{copiato dal manuale xilix}
This section explains how to add custom applications to PetaLinux root file system.
\subsubsection{Steps to Add Custom Applications}
The basic steps are as follows:
\begin{itemize}
\item Create a user application by running petalinux-create -t apps from inside a PetaLinux
project on your workstation:
\begin{verbatim}
cd <plnx-proj-root>
petalinux-create -t apps [--template TYPE] --name <user-application_name> --enable
\end{verbatim}
For example, to create a user application called \textit{myapp} in C (by default):
\begin{verbatim}
petalinux-create -t apps --name myapp --enable
\end{verbatim}
or:
\begin{verbatim}
petalinux-create -t apps --template c --name myapp --enable
\end{verbatim}
To create a C++ application template, pass the --template c++ option, as follows:
\begin{verbatim}
petalinux-create -t apps --template c++ --name myapp --enable
\end{verbatim}
(do NOT use '\_' in the app name)\\
To create an autoconf application template, pass the --template autoconf option, as
follows:
\begin{verbatim}
petalinux-create -t apps --template autoconf --name myapp --enable
\end{verbatim}
The new application created can be found in the:
\textit{"<plnx-proj-root>/project-spec/meta-user/recipes-apps/myapp"} directory.
\item Change to the newly created application directory.
\begin{verbatim}
cd <plnx-proj-root>/project-spec/meta-user/recipes-apps/myapp
\end{verbatim}
You will see the following PetaLinux template-generated files:
\end{itemize}

\chapter{Kintex side}

\chapter{Embedded processor}

\chapter{Tests}

\end{document}